Index: pacemaker/pengine/test10/master-demote-2.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-demote-2.exp
+++ pacemaker/pengine/test10/master-demote-2.exp
@@ -36,7 +36,7 @@
     <action_set>
       <rsc_op id="19" operation="monitor" operation_key="r192.168.122.105_monitor_5000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.105" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.105"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.105"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -49,7 +49,7 @@
     <action_set>
       <rsc_op id="18" operation="start" operation_key="r192.168.122.105_start_0" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.105" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.105"/>
+        <attributes CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.105"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -62,7 +62,7 @@
     <action_set>
       <rsc_op id="21" operation="monitor" operation_key="r192.168.122.106_monitor_5000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.106" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.106"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.106"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -75,7 +75,7 @@
     <action_set>
       <rsc_op id="20" operation="start" operation_key="r192.168.122.106_start_0" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.106" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.106"/>
+        <attributes CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.106"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -91,7 +91,7 @@
     <action_set>
       <rsc_op id="23" operation="monitor" operation_key="r192.168.122.107_monitor_5000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.107" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.107"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.107"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -104,7 +104,7 @@
     <action_set>
       <rsc_op id="22" operation="start" operation_key="r192.168.122.107_start_0" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="r192.168.122.107" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.107"/>
+        <attributes CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" cidr_netmask="32"  ip="192.168.122.107"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -120,7 +120,7 @@
     <action_set>
       <rsc_op id="37" operation="monitor" operation_key="lsb-dummy_monitor_5000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="lsb-dummy" class="lsb" type="/usr/share/pacemaker/tests/cts/LSBDummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -133,7 +133,7 @@
     <action_set>
       <rsc_op id="36" operation="start" operation_key="lsb-dummy_start_0" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="lsb-dummy" class="lsb" type="/usr/share/pacemaker/tests/cts/LSBDummy"/>
-        <attributes CRM_meta_timeout="60000" />
+        <attributes CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -146,7 +146,7 @@
     <action_set>
       <rsc_op id="53" operation="monitor" operation_key="stateful-1:1_monitor_15000" internal_operation_key="stateful-1:0_monitor_15000" on_node="pcmk-1" on_node_uuid="pcmk-1">
         <primitive id="stateful-1" long-id="stateful-1:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="15000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="15000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="pcmk-1" CRM_meta_on_node_uuid="pcmk-1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -159,7 +159,7 @@
     <action_set>
       <rsc_op id="52" operation="start" operation_key="stateful-1:1_start_0" internal_operation_key="stateful-1:0_start_0" on_node="pcmk-1" on_node_uuid="pcmk-1">
         <primitive id="stateful-1" long-id="stateful-1:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="pcmk-1" CRM_meta_on_node_uuid="pcmk-1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -175,7 +175,7 @@
     <action_set>
       <rsc_op id="1" operation="stop" operation_key="stateful-1:1_stop_0" internal_operation_key="stateful-1:0_stop_0" on_node="pcmk-1" on_node_uuid="pcmk-1">
         <primitive id="stateful-1" long-id="stateful-1:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="pcmk-1" CRM_meta_on_node_uuid="pcmk-1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -188,7 +188,7 @@
     <action_set>
       <rsc_op id="57" operation="monitor" operation_key="stateful-1:0_monitor_16000" internal_operation_key="stateful-1:1_monitor_16000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="stateful-1" long-id="stateful-1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="16000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="16000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -201,7 +201,7 @@
     <action_set>
       <rsc_op id="56" operation="promote" operation_key="stateful-1:0_promote_0" internal_operation_key="stateful-1:1_promote_0" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="stateful-1" long-id="stateful-1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -217,7 +217,7 @@
     <action_set>
       <rsc_op id="5" operation="cancel" operation_key="stateful-1:0_monitor_15000" internal_operation_key="stateful-1:1_monitor_15000" on_node="pcmk-2" on_node_uuid="pcmk-2">
         <primitive id="stateful-1" long-id="stateful-1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="15000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_operation="monitor" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="15000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="pcmk-2" CRM_meta_on_node_uuid="pcmk-2" CRM_meta_operation="monitor" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/master-demote-block.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-demote-block.exp
+++ pacemaker/pengine/test10/master-demote-block.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="dummy:1_monitor_20000" on_node="dl380g5d" on_node_uuid="3f6ec88d-ee47-4f63-bfeb-652b8dd96027">
         <primitive id="dummy" long-id="dummy:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="restart" CRM_meta_role="Slave" CRM_meta_timeout="100000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="restart" CRM_meta_on_node="dl380g5d" CRM_meta_on_node_uuid="3f6ec88d-ee47-4f63-bfeb-652b8dd96027" CRM_meta_role="Slave" CRM_meta_timeout="100000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/master-failed-demote-2.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-failed-demote-2.exp
+++ pacemaker/pengine/test10/master-failed-demote-2.exp
@@ -30,7 +30,7 @@
      <action_set>
       <rsc_op id="4" operation="stop" operation_key="stateful-1:0_stop_0" on_node="dl380g5b" on_node_uuid="888e539a-c6ef-496d-b79a-77cbf0f9e5e4">
         <primitive id="stateful-1:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="dl380g5b" CRM_meta_on_node_uuid="888e539a-c6ef-496d-b79a-77cbf0f9e5e4" CRM_meta_timeout="60000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -70,7 +70,7 @@
      <action_set>
       <rsc_op id="16" operation="monitor" operation_key="stateful-1:1_monitor_10000" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-1:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -83,7 +83,7 @@
      <action_set>
       <rsc_op id="15" operation="promote" operation_key="stateful-1:1_promote_0" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-1:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="120000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_timeout="120000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -99,7 +99,7 @@
      <action_set>
       <rsc_op id="1" operation="cancel" operation_key="stateful-1:1_monitor_20000" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-1:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_operation="monitor" CRM_meta_role="Slave" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_operation="monitor" CRM_meta_role="Slave" CRM_meta_timeout="60000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -108,7 +108,7 @@
      <action_set>
       <rsc_op id="20" operation="monitor" operation_key="stateful-2:1_monitor_10000" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="60000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -121,7 +121,7 @@
      <action_set>
       <rsc_op id="19" operation="promote" operation_key="stateful-2:1_promote_0" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="120000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_timeout="120000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -140,7 +140,7 @@
      <action_set>
       <rsc_op id="2" operation="cancel" operation_key="stateful-2:1_monitor_20000" on_node="dl380g5a" on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_operation="monitor" CRM_meta_role="Slave" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="dl380g5a" CRM_meta_on_node_uuid="3831f23f-da0a-470e-b8e7-16e61a18c3c3" CRM_meta_operation="monitor" CRM_meta_role="Slave" CRM_meta_timeout="60000" />
        </rsc_op>
      </action_set>
      <inputs/>
Index: pacemaker/pengine/test10/master-group.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-group.exp
+++ pacemaker/pengine/test10/master-group.exp
@@ -27,7 +27,7 @@
      <action_set>
       <rsc_op id="24" operation="monitor" operation_key="master_slave_Stateful:1_monitor_6000" on_node="rh44-1" on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8">
         <primitive id="master_slave_Stateful:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="6000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="6000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="rh44-1" CRM_meta_on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="30000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -40,7 +40,7 @@
      <action_set>
       <rsc_op id="23" operation="promote" operation_key="master_slave_Stateful:1_promote_0" on_node="rh44-1" on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8">
         <primitive id="master_slave_Stateful:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="120000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="rh44-1" CRM_meta_on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8" CRM_meta_timeout="120000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -56,7 +56,7 @@
      <action_set>
       <rsc_op id="1" operation="cancel" operation_key="master_slave_Stateful:1_monitor_5000" on_node="rh44-1" on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8">
         <primitive id="master_slave_Stateful:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="5000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_operation="monitor" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_interval="5000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="rh44-1" CRM_meta_on_node_uuid="782b1222-d1b9-4993-8f0d-b8b67801a2c8" CRM_meta_operation="monitor" CRM_meta_timeout="30000" />
        </rsc_op>
      </action_set>
      <inputs/>
Index: pacemaker/pengine/test10/master-promotion-constraint.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-promotion-constraint.exp
+++ pacemaker/pengine/test10/master-promotion-constraint.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="13" operation="monitor" operation_key="s0:1_monitor_21000" internal_operation_key="s0:0_monitor_21000" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="21000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_role="Slave" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="21000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_role="Slave" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="11" operation="demote" operation_key="s0:1_demote_0" internal_operation_key="s0:0_demote_0" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -32,7 +32,7 @@
     <action_set>
       <rsc_op id="1" operation="cancel" operation_key="s0:1_monitor_20000" internal_operation_key="s0:0_monitor_20000" on_node="hex-14" on_node_uuid="hex-14">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_operation="monitor" CRM_meta_role="Master" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="hex-14" CRM_meta_on_node_uuid="hex-14" CRM_meta_operation="monitor" CRM_meta_role="Master" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/master-reattach.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-reattach.exp
+++ pacemaker/pengine/test10/master-reattach.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="drbd1:0_monitor_10000" on_node="dktest1" on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25">
         <primitive id="drbd1" long-id="drbd1:0" class="ocf" provider="heartbeat" type="drbd"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="true" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="15000"  drbd_resource="drbd1"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="true" CRM_meta_on_node="dktest1" CRM_meta_on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="15000"  drbd_resource="drbd1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="8" operation="monitor" operation_key="drbd1:0_monitor_11000" internal_operation_key="drbd1:1_monitor_11000" on_node="dktest2" on_node_uuid="f430bc66-3388-4b7d-9e99-24fb02855f54">
         <primitive id="drbd1" long-id="drbd1:0" class="ocf" provider="heartbeat" type="drbd"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="11000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="true" CRM_meta_role="Slave" CRM_meta_timeout="15000"  drbd_resource="drbd1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="11000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="true" CRM_meta_on_node="dktest2" CRM_meta_on_node_uuid="f430bc66-3388-4b7d-9e99-24fb02855f54" CRM_meta_role="Slave" CRM_meta_timeout="15000"  drbd_resource="drbd1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -21,7 +21,7 @@
     <action_set>
       <rsc_op id="36" operation="monitor" operation_key="apache-vip_monitor_60000" on_node="dktest1" on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25">
         <primitive id="apache-vip" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="15000" broadcast="10.200.200.255" cidr_netmask="24"  ip="10.200.200.224" nic="eth1"/>
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="dktest1" CRM_meta_on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25" CRM_meta_timeout="15000" broadcast="10.200.200.255" cidr_netmask="24"  ip="10.200.200.224" nic="eth1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -30,7 +30,7 @@
     <action_set>
       <rsc_op id="39" operation="monitor" operation_key="mount_monitor_10000" on_node="dktest1" on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25">
         <primitive id="mount" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_enabled="true" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_role="Started" CRM_meta_timeout="5000"  device="/dev/drbd1" directory="/srv" fstype="ext3"/>
+        <attributes CRM_meta_enabled="true" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="dktest1" CRM_meta_on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25" CRM_meta_role="Started" CRM_meta_timeout="5000"  device="/dev/drbd1" directory="/srv" fstype="ext3"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -39,7 +39,7 @@
     <action_set>
       <rsc_op id="42" operation="monitor" operation_key="webserver_monitor_30000" on_node="dktest1" on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25">
         <primitive id="webserver" class="ocf" provider="heartbeat" type="apache"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_timeout="30000" configfile="/srv/apache/conf/httpd.conf"  httpd="/srv/apache/bin/httpd" port="80" testregex="test"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="dktest1" CRM_meta_on_node_uuid="c738bee8-591f-4653-aaad-20a961923f25" CRM_meta_timeout="30000" configfile="/srv/apache/conf/httpd.conf"  httpd="/srv/apache/bin/httpd" port="80" testregex="test"/>
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/master-role.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-role.exp
+++ pacemaker/pengine/test10/master-role.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="7" operation="demote" operation_key="res_Stateful_1:0_demote_0" internal_operation_key="res_Stateful_1:1_demote_0" on_node="sles11-a" on_node_uuid="bb56fda4-7d0d-405c-a6e4-c21b0e070303">
         <primitive id="res_Stateful_1" long-id="res_Stateful_1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="sles11-a" CRM_meta_on_node_uuid="bb56fda4-7d0d-405c-a6e4-c21b0e070303" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
